import { Observable } from "rxjs";
import type { ImxEnv } from "@rarible/immutable-wallet";
import { ImxWallet } from "@rarible/immutable-wallet";
import type { ConnectionState, Maybe } from "@rarible/connector";
import { AbstractConnectionProvider } from "@rarible/connector";
import type { IImmutableXProviderConnectionResult } from "@rarible/connector-helper";
export declare type WalletConfig = {
    env: ImxEnv;
};
declare type ConnectStatus = "connected" | "disconnected";
declare const PROVIDER_ID: "immutablex";
export declare class ImmutableXLinkConnectionProvider extends AbstractConnectionProvider<typeof PROVIDER_ID, IImmutableXProviderConnectionResult> {
    private readonly config;
    private readonly instance;
    private readonly connection;
    constructor(config: WalletConfig);
    private _connect;
    getId(): string;
    getAddress(wallet: ImxWallet): Observable<string>;
    getConnectedStatus(_wallet: ImxWallet): Observable<ConnectStatus>;
    private toConnectState;
    getConnection(): Observable<ConnectionState<IImmutableXProviderConnectionResult>>;
    getOption(): Promise<Maybe<typeof PROVIDER_ID>>;
    isAutoConnected(): Promise<boolean>;
    isConnected(): Promise<boolean>;
}
export {};
