import type { BigNumberT } from "@imtbl/imx-sdk";
import type { ApiResponse } from "@rarible/ethereum-api-client";
import { BaseAPI } from "@rarible/ethereum-api-client";
export interface GetAllBalancesRequest {
    ownerAddress: string;
}
export interface GetAllBalancesResponse {
    "result": {
        "symbol": string;
        "balance": BigNumberT;
        "preparing_withdrawal": string;
        "token_address": string;
        "withdrawable": string;
    }[];
    "cursor": string;
}
export declare class ImxBalanceControllerApi extends BaseAPI {
    getAllBalancesRaw(requestParameters: GetAllBalancesRequest): Promise<ApiResponse<GetAllBalancesResponse>>;
    /**
     */
    getAllBalances(requestParameters: GetAllBalancesRequest): Promise<GetAllBalancesResponse>;
}
