"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImxBalanceControllerApi = void 0;
var tslib_1 = require("tslib");
var ethereum_api_client_1 = require("@rarible/ethereum-api-client");
var ImxBalanceControllerApi = /** @class */ (function (_super) {
    tslib_1.__extends(ImxBalanceControllerApi, _super);
    function ImxBalanceControllerApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ImxBalanceControllerApi.prototype.getAllBalancesRaw = function (requestParameters) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var queryParameters, headerParameters, response;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (requestParameters.ownerAddress === null || requestParameters.ownerAddress === undefined) {
                            throw new ethereum_api_client_1.RequiredError("ownerAddress", "Required parameter requestParameters.ownerAddress was null or undefined when calling getAllBalances.");
                        }
                        queryParameters = {};
                        headerParameters = {};
                        return [4 /*yield*/, this.request({
                                path: "/balances/{address}".replace("{".concat("address", "}"), encodeURIComponent(String(requestParameters.ownerAddress))),
                                method: "GET",
                                headers: headerParameters,
                                query: queryParameters,
                            })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, new ethereum_api_client_1.JSONApiResponse(response, function (jsonValue) { return jsonValue; })];
                }
            });
        });
    };
    /**
     */
    ImxBalanceControllerApi.prototype.getAllBalances = function (requestParameters) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var response;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getAllBalancesRaw(requestParameters)];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.value()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return ImxBalanceControllerApi;
}(ethereum_api_client_1.BaseAPI));
exports.ImxBalanceControllerApi = ImxBalanceControllerApi;
