"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBalance = void 0;
var tslib_1 = require("tslib");
var ethereum_api_client_1 = require("@rarible/ethereum-api-client");
var utils_1 = require("@rarible/utils");
var apis_1 = require("../apis");
var env_1 = require("../config/env");
function getBalance(env, address, assetType) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var DEFAULT_DECIMALS, apiAddressV2, balanceApiConfig, api, result, currencyBalance, currencyBalance;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    DEFAULT_DECIMALS = 18;
                    apiAddressV2 = env_1.IMX_ENV_CONFIG[env].apiAddressV2;
                    balanceApiConfig = new ethereum_api_client_1.Configuration({ basePath: apiAddressV2 });
                    api = new apis_1.ImxBalanceControllerApi(balanceApiConfig);
                    return [4 /*yield*/, api.getAllBalances({ ownerAddress: address })];
                case 1:
                    result = (_a.sent()).result;
                    if (assetType.assetClass === "ETH") {
                        currencyBalance = result.find((function (b) { return b.token_address === ""; }));
                        if (currencyBalance) {
                            return [2 /*return*/, (0, utils_1.toBn)(currencyBalance.balance.toString()).dividedBy(Math.pow(10, DEFAULT_DECIMALS))];
                        }
                    }
                    else if (assetType.assetClass === "ERC20") {
                        currencyBalance = result.find(function (b) { var _a; return ((_a = b.token_address) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === assetType.contract.toLowerCase(); });
                        if (currencyBalance) {
                            return [2 /*return*/, (0, utils_1.toBn)(currencyBalance.balance.toString()).dividedBy(Math.pow(10, DEFAULT_DECIMALS))];
                        }
                    }
                    return [2 /*return*/, (0, utils_1.toBn)("0")];
            }
        });
    });
}
exports.getBalance = getBalance;
