"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateImxFeePercents = exports.convertFees = void 0;
var utils_1 = require("@rarible/utils");
function convertFees(fee) {
    var prepared = fee === null || fee === void 0 ? void 0 : fee.map(function (f) {
        var value = (new utils_1.BigNumber(f.value)).div(100).toNumber();
        validateImxFeePercents(value);
        return { recipient: f.account, percentage: value };
    });
    return (prepared === null || prepared === void 0 ? void 0 : prepared.filter(function (v) { return v.percentage !== 0; })) || [];
}
exports.convertFees = convertFees;
function validateImxFeePercents(value) {
    if (value < 0 || value > 100) {
        throw new Error("Invalid value for fee, should be a number greater then 0 and lower then");
    }
}
exports.validateImxFeePercents = validateImxFeePercents;
