"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.burn = void 0;
var tslib_1 = require("tslib");
var imx_sdk_1 = require("@imtbl/imx-sdk");
var types_1 = require("@rarible/types");
var get_tranfer_response_1 = require("./common/get-tranfer-response");
function burn(link, request) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var assetClass, tokenId, contract, result, resp;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (link === undefined) {
                        throw new Error("Wallet undefined");
                    }
                    assetClass = request.assetClass, tokenId = request.tokenId, contract = request.contract;
                    if (assetClass !== imx_sdk_1.ERC721TokenType.ERC721) {
                        throw new Error("Unsupported assetClass");
                    }
                    return [4 /*yield*/, link.transfer([{
                                type: imx_sdk_1.ERC721TokenType.ERC721,
                                tokenId: tokenId,
                                tokenAddress: contract,
                                toAddress: types_1.ZERO_ADDRESS,
                            }])];
                case 1:
                    result = (_a.sent()).result;
                    resp = result[0];
                    return [2 /*return*/, (0, get_tranfer_response_1.getTransferResponse)(resp)];
            }
        });
    });
}
exports.burn = burn;
