import type { BigNumber, Erc20AssetType, Erc721AssetType, EthAssetType, Part } from "@rarible/ethereum-api-client";
export declare type OrderRequest = {
    payouts: Part[];
    originFees: Part[];
};
export declare type SellRequest = {
    makeAssetType: Erc721AssetType;
    takeAssetType: EthAssetType | Erc20AssetType;
    amount: BigNumber;
} & OrderRequest;
export declare type SellResponseRaw = {
    order_id: number;
    status: string;
};
export interface SellResponse {
    orderId: number;
}
export declare type BuyRequest = {
    orderId: string;
    fee: Part[];
};
export declare type BuyResponse = {
    txId: number | undefined;
};
export declare type CancelOrderRequest = {
    orderId: string;
};
export interface CancelOrderResponse extends CancelOrderRequest {
}
