import type { Link } from "@imtbl/imx-sdk";
export declare type ImxNetwork = "mainnet" | "ropsten";
export declare type ImxEnv = "dev" | "prod";
export declare enum ImxWalletProviderEnum {
    METAMASK = "METAMASK",
    MAGIC_LINK = "MAGIC_LINK",
    WALLET_CONNECT = "WALLET_CONNECT",
    NONE = "NONE"
}
export declare type ImxNetworkConfig = {
    network: ImxNetwork;
    linkAddress: string;
    gasLimit?: string;
    gasPrice?: string;
    enableDebug?: boolean;
};
export declare type ImxConnectResult = {
    address: string;
    ethNetwork: string;
    providerPreference: string;
    starkPublicKey: string;
};
export declare type ImxConnectionData = ImxConnectResult & {
    link: Link;
    status: ImxWalletConnectionStatus;
};
export declare type ImxWalletConnectionStatus = "connected" | "disconnected";
