"use strict";
/**
 * Note: this example should be compiled with any build tool like webpack and run from browser
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var sdk_1 = require("@rarible/sdk");
var immutable_wallet_1 = require("@rarible/immutable-wallet");
var sdk_wallet_1 = require("@rarible/sdk-wallet");
var types_1 = require("@rarible/types");
function getSdk() {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var imxConnectorWallet, wallet;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    imxConnectorWallet = new immutable_wallet_1.ImxWallet("dev");
                    return [4 /*yield*/, imxConnectorWallet.connect()];
                case 1:
                    _a.sent();
                    wallet = new sdk_wallet_1.ImmutableXWallet(imxConnectorWallet);
                    console.log({
                        status: imxConnectorWallet.getConnectionData().status,
                        address: imxConnectorWallet.getConnectionData().address,
                    });
                    return [2 /*return*/, (0, sdk_1.createRaribleSdk)(wallet, "development")];
            }
        });
    });
}
// eslint-disable-next-line @typescript-eslint/no-unused-vars
function burn(sdk, itemId) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var prepare;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sdk.nft.burn({
                        itemId: itemId,
                    })];
                case 1:
                    prepare = _a.sent();
                    return [4 /*yield*/, prepare.submit({
                            amount: 1,
                        })];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
// eslint-disable-next-line @typescript-eslint/no-unused-vars
function transfer(sdk, itemId, receiver) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var prepare;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sdk.nft.transfer({
                        itemId: itemId,
                    })];
                case 1:
                    prepare = _a.sent();
                    return [4 /*yield*/, prepare.submit({
                            amount: 1,
                            to: receiver,
                        })];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function sell(sdk, itemId, price) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var prepare;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sdk.order.sell({
                        itemId: itemId,
                    })];
                case 1:
                    prepare = _a.sent();
                    return [4 /*yield*/, prepare.submit({
                            amount: 1,
                            price: price,
                            currency: { "@type": "ETH" },
                        })];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function buy(sdk, orderId) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var prepare;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sdk.order.buy({
                        orderId: orderId,
                    })];
                case 1:
                    prepare = _a.sent();
                    return [4 /*yield*/, prepare.submit({
                            amount: 1,
                        })];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
// eslint-disable-next-line @typescript-eslint/no-unused-vars
function cancel(sdk, orderId) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            return [2 /*return*/, sdk.order.cancel({
                    orderId: orderId,
                })];
        });
    });
}
function run() {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var sdk, tx, orderId, e_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 6, , 7]);
                    return [4 /*yield*/, getSdk()];
                case 1:
                    sdk = _a.sent();
                    tx = void 0;
                    return [4 /*yield*/, sell(sdk, (0, types_1.toItemId)("IMMUTABLEX:<YOUR_COLLECTION_ID>:<YOUR_ITEM_ID>"), 0.001)
                        /** cancel order **/
                        // tx = await cancel(sdk, orderId)
                        /** buy item **/
                    ];
                case 2:
                    orderId = _a.sent();
                    return [4 /*yield*/, buy(sdk, orderId)
                        /** waiting for transaction **/
                    ];
                case 3:
                    /** cancel order **/
                    // tx = await cancel(sdk, orderId)
                    /** buy item **/
                    tx = _a.sent();
                    if (!!tx.isEmpty) return [3 /*break*/, 5];
                    return [4 /*yield*/, tx.wait()];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5: return [3 /*break*/, 7];
                case 6:
                    e_1 = _a.sent();
                    console.error(e_1);
                    return [3 /*break*/, 7];
                case 7: return [2 /*return*/];
            }
        });
    });
}
run();
