import type { Maybe } from "@rarible/types/build/maybe";
import type { CollectionId } from "@rarible/api-client";
import { WalletType } from "@rarible/sdk-wallet";
import type { BlockchainWallet } from "@rarible/sdk-wallet";
import type { IRaribleSdk, IRaribleSdkConfig } from "./domain";
import type { MintAndSellRequest } from "./types/nft/mint-and-sell/domain";
import type { HasCollection, HasCollectionId } from "./types/nft/mint/prepare-mint-request.type";
import type { RaribleSdkEnvironment } from "./config/domain";
export declare function createRaribleSdk(wallet: Maybe<BlockchainWallet>, env: RaribleSdkEnvironment, config?: IRaribleSdkConfig): IRaribleSdk;
export declare function getCollectionId(req: HasCollectionId | HasCollection): CollectionId;
export { WalletType };
export { getSimpleFlowFungibleBalance } from "./sdk-blockchains/flow/balance-simple";
export { IRaribleSdk, MintAndSellRequest };
export { RequestCurrency } from "./common/domain";
export { UnionPart } from "./types/order/common/index";
