"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImxBalanceService = void 0;
var tslib_1 = require("tslib");
var types_1 = require("@rarible/types");
var get_currency_asset_type_1 = require("../../common/get-currency-asset-type");
var utils_1 = require("./common/utils");
var ImxBalanceService = /** @class */ (function () {
    function ImxBalanceService(sdk, apis) {
        this.sdk = sdk;
        this.apis = apis;
        this.getBalance = this.getBalance.bind(this);
    }
    ImxBalanceService.prototype.getBalance = function (address, currency) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var assetType, _a, _b, contractAddress;
            return tslib_1.__generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        assetType = (0, get_currency_asset_type_1.getCurrencyAssetType)(currency);
                        _a = assetType["@type"];
                        switch (_a) {
                            case "ETH": return [3 /*break*/, 1];
                            case "ERC20": return [3 /*break*/, 3];
                        }
                        return [3 /*break*/, 5];
                    case 1: return [4 /*yield*/, this.sdk.balance.getBalance((0, utils_1.convertToEthereumAddress)(address), { assetClass: "ETH" })];
                    case 2: return [2 /*return*/, _c.sent()];
                    case 3:
                        _b = tslib_1.__read(assetType.contract.split(":"), 2), contractAddress = _b[1];
                        return [4 /*yield*/, this.sdk.balance.getBalance((0, utils_1.convertToEthereumAddress)(address), {
                                assetClass: "ERC20",
                                contract: (0, types_1.toAddress)(contractAddress),
                            })];
                    case 4: return [2 /*return*/, _c.sent()];
                    case 5: throw new Error("Unsupported asset type");
                }
            });
        });
    };
    return ImxBalanceService;
}());
exports.ImxBalanceService = ImxBalanceService;
