import type { Part } from "@rarible/ethereum-api-client";
import type { CollectionId, Creator, Order } from "@rarible/api-client";
import type { ContractAddress } from "@rarible/types/build/contract-address";
import type { Address, UnionAddress } from "@rarible/types";
import type { PrepareFillRequest } from "../../../types/order/fill/domain";
import type { IApisSdk } from "../../../domain";
import type { UnionPart } from "../../../types/order/common";
import type { RequestCurrency } from "../../../common/domain";
export declare function getPreparedOrder(request: PrepareFillRequest, apis: IApisSdk): Promise<Order>;
export declare function convertToEthereumAddress(contractAddress: UnionAddress | ContractAddress | CollectionId): Address;
export declare function unionPartsToParts(parts: UnionPart[] | Creator[] | undefined): Part[];
export declare function getTakeAssetType(currency: RequestCurrency): {
    assetClass: "ERC20";
    contract: Address;
} | {
    assetClass: "ETH";
    contract?: undefined;
};
export declare function calcBuyerBaseFee(order: Order): number;
