"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImxNftService = void 0;
var tslib_1 = require("tslib");
var sdk_transaction_1 = require("@rarible/sdk-transaction");
var types_1 = require("@rarible/types");
var action_1 = require("@rarible/action");
var ImxNftService = /** @class */ (function () {
    function ImxNftService(sdk, apis) {
        this.sdk = sdk;
        this.apis = apis;
        this.burn = this.burn.bind(this);
        this.transfer = this.transfer.bind(this);
    }
    ImxNftService.prototype.burn = function (prepare) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, {
                        multiple: false,
                        maxAmount: (0, types_1.toBigNumber)("1"),
                        submit: action_1.Action.create({
                            id: "burn",
                            run: function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                var _a, contract, tokenId, res;
                                return tslib_1.__generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            _a = tslib_1.__read(prepare.itemId.split(":"), 3), contract = _a[1], tokenId = _a[2];
                                            return [4 /*yield*/, this.sdk.nft.burn({
                                                    assetClass: "ERC721",
                                                    tokenId: (0, types_1.toBigNumber)(tokenId),
                                                    contract: (0, types_1.toAddress)(contract),
                                                })];
                                        case 1:
                                            res = _b.sent();
                                            return [2 /*return*/, new sdk_transaction_1.BlockchainImmutableXTransaction(res.txId)];
                                    }
                                });
                            }); },
                        }),
                    }];
            });
        });
    };
    ImxNftService.prototype.transfer = function (prepare) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, {
                        multiple: false,
                        maxAmount: (0, types_1.toBigNumber)("1"),
                        submit: action_1.Action.create({
                            id: "transfer",
                            run: function (request) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                                var _a, contract, tokenId, _b, address, res;
                                return tslib_1.__generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            _a = tslib_1.__read(prepare.itemId.split(":"), 3), contract = _a[1], tokenId = _a[2];
                                            _b = tslib_1.__read(request.to.split(":"), 2), address = _b[1];
                                            return [4 /*yield*/, this.sdk.nft.transfer({
                                                    assetClass: "ERC721",
                                                    to: (0, types_1.toAddress)(address),
                                                    tokenId: (0, types_1.toBigNumber)(tokenId),
                                                    contract: (0, types_1.toAddress)(contract),
                                                })];
                                        case 1:
                                            res = _c.sent();
                                            return [2 /*return*/, new sdk_transaction_1.BlockchainImmutableXTransaction(res.txId)];
                                    }
                                });
                            }); },
                        }),
                    }];
            });
        });
    };
    return ImxNftService;
}());
exports.ImxNftService = ImxNftService;
