import BigNumber from "bignumber.js";
import type { SolanaAuctionHouseDataV1 } from "@rarible/api-client/build/models/OrderData";
import type { ItemId, Order, OrderId } from "@rarible/api-client";
import type { PublicKey } from "@solana/web3.js";
import type { PrepareFillRequest } from "../../../types/order/fill/domain";
import type { IApisSdk } from "../../../domain";
export declare function getOrderId(orderType: "BUY" | "SELL", maker: string, itemId: string, auctionHouse: string): OrderId;
export declare function getPreparedOrder(request: PrepareFillRequest, apis: IApisSdk): Promise<Order>;
export declare function getOrderData(order: Order): SolanaAuctionHouseDataV1;
export declare function getMintId(order: Order): PublicKey;
export declare function getItemId(mint: PublicKey): ItemId;
export declare function getPrice(order: Order): BigNumber;
export declare function getTokensAmount(order: Order): BigNumber;
