"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SolanaAccountSdk = void 0;
var tslib_1 = require("tslib");
var prepared_transaction_1 = require("../prepared-transaction");
var common_1 = require("../../tests/common");
var helpers_1 = require("../../common/helpers");
var revoke_1 = require("./methods/revoke");
var SolanaAccountSdk = /** @class */ (function () {
    function SolanaAccountSdk(connection, logger) {
        this.connection = connection;
        this.logger = logger;
    }
    SolanaAccountSdk.prototype.getTokenAccountForMint = function (request) {
        var _a;
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var tokenAccount;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, (0, common_1.getTokenAccounts)(this.connection, request.owner, request.mint)];
                    case 1:
                        tokenAccount = _b.sent();
                        return [2 /*return*/, (_a = tokenAccount === null || tokenAccount === void 0 ? void 0 : tokenAccount.value[0]) === null || _a === void 0 ? void 0 : _a.pubkey];
                }
            });
        });
    };
    SolanaAccountSdk.prototype.getAccountInfo = function (request) {
        return (0, helpers_1.getAccountInfo)(this.connection, request.mint, null, request.tokenAccount);
    };
    SolanaAccountSdk.prototype.revokeDelegate = function (request) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var instructions;
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, revoke_1.getAccountRevokeDelegateInstructions)({
                            connection: this.connection,
                            signer: request.signer,
                            tokenAccount: request.tokenAccount,
                        })];
                    case 1:
                        instructions = _a.sent();
                        return [2 /*return*/, new prepared_transaction_1.PreparedTransaction(this.connection, instructions, request.signer, this.logger, function () {
                                _this.logger.log("".concat(request.tokenAccount.toString(), " delegation revoked"));
                            })];
                }
            });
        });
    };
    return SolanaAccountSdk;
}());
exports.SolanaAccountSdk = SolanaAccountSdk;
