"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SolanaBalancesSdk = void 0;
var tslib_1 = require("tslib");
var bignumber_js_1 = tslib_1.__importDefault(require("bignumber.js"));
var web3_js_1 = require("@solana/web3.js");
var SolanaBalancesSdk = /** @class */ (function () {
    function SolanaBalancesSdk(connection, logger) {
        this.connection = connection;
        this.logger = logger;
    }
    SolanaBalancesSdk.prototype.getBalance = function (publicKey, options) {
        var _a;
        if (options === void 0) { options = {}; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _b;
            return tslib_1.__generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _b = bignumber_js_1.default.bind;
                        return [4 /*yield*/, this.connection.getBalance(publicKey, (_a = options.commitment) !== null && _a !== void 0 ? _a : "confirmed")];
                    case 1: return [2 /*return*/, new (_b.apply(bignumber_js_1.default, [void 0, _c.sent()]))().dividedBy(web3_js_1.LAMPORTS_PER_SOL)];
                }
            });
        });
    };
    SolanaBalancesSdk.prototype.getTokenBalance = function (owner, mint, options) {
        var _a, _b, _c;
        if (options === void 0) { options = {}; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var accounts, res, _d, _e, tokenAccount, balance, e_1_1;
            var e_1, _f;
            return tslib_1.__generator(this, function (_g) {
                switch (_g.label) {
                    case 0: return [4 /*yield*/, this.connection.getTokenAccountsByOwner(owner, { mint: mint })];
                    case 1:
                        accounts = _g.sent();
                        res = new bignumber_js_1.default(0);
                        _g.label = 2;
                    case 2:
                        _g.trys.push([2, 7, 8, 9]);
                        _d = tslib_1.__values(accounts.value), _e = _d.next();
                        _g.label = 3;
                    case 3:
                        if (!!_e.done) return [3 /*break*/, 6];
                        tokenAccount = _e.value;
                        return [4 /*yield*/, this.connection.getTokenAccountBalance(tokenAccount.pubkey, (_a = options.commitment) !== null && _a !== void 0 ? _a : "confirmed")];
                    case 4:
                        balance = _g.sent();
                        res = res.plus(new bignumber_js_1.default((_c = (_b = balance === null || balance === void 0 ? void 0 : balance.value) === null || _b === void 0 ? void 0 : _b.uiAmountString) !== null && _c !== void 0 ? _c : 0));
                        _g.label = 5;
                    case 5:
                        _e = _d.next();
                        return [3 /*break*/, 3];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_1_1 = _g.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 9:
                        this.logger.log("Wallet ".concat(owner, " have ").concat(res, " of ").concat(mint.toString(), " tokens"));
                        return [2 /*return*/, res];
                }
            });
        });
    };
    return SolanaBalancesSdk;
}());
exports.SolanaBalancesSdk = SolanaBalancesSdk;
