"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAddressParts = exports.web3Provider = exports.initWeb3Provider = void 0;
const web3_1 = __importDefault(require("web3"));
function initWeb3Provider(rpcUrl) {
    return new web3_1.default(new web3_1.default.providers.HttpProvider(rpcUrl));
}
exports.initWeb3Provider = initWeb3Provider;
if (!process.env.RPC_URL) {
    throw new Error("RPC_URL env variable has not been set");
}
exports.web3Provider = initWeb3Provider(process.env.RPC_URL);
function getAddressParts(address) {
    const parts = address.split(":");
    return {
        blockchain: parts[0],
        address: parts[1],
    };
}
exports.getAddressParts = getAddressParts;
//# sourceMappingURL=index.js.map