import { Blockchain } from "@rarible/api-client";
import type { EthereumTransaction } from "@rarible/ethereum-provider";
import type { EthereumNetwork } from "@rarible/protocol-ethereum-sdk/build/types";
import type { IBlockchainTransaction } from "../domain";
export declare class BlockchainEthereumTransaction<TransactionResult = undefined> implements IBlockchainTransaction<Blockchain, TransactionResult> {
    transaction: EthereumTransaction;
    network: EthereumNetwork;
    resultExtractor?: ((receipt: Awaited<ReturnType<EthereumTransaction["wait"]>>) => TransactionResult | undefined) | undefined;
    blockchain: Blockchain;
    constructor(transaction: EthereumTransaction, network: EthereumNetwork, resultExtractor?: ((receipt: Awaited<ReturnType<EthereumTransaction["wait"]>>) => TransactionResult | undefined) | undefined);
    private getBlockchain;
    hash(): import("@rarible/types").Word;
    wait(): Promise<{
        blockchain: Blockchain;
        hash: import("@rarible/types").Word;
        result: TransactionResult | undefined;
    }>;
    getTxLink(): string;
    get isEmpty(): boolean;
}
