"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlockchainImmutableXTransaction = void 0;
var tslib_1 = require("tslib");
var api_client_1 = require("@rarible/api-client");
var BlockchainImmutableXTransaction = /** @class */ (function () {
    function BlockchainImmutableXTransaction(transaction) {
        this.transaction = transaction;
        this.blockchain = api_client_1.Blockchain.IMMUTABLEX;
    }
    BlockchainImmutableXTransaction.prototype.hash = function () {
        var _a;
        return ((_a = this.transaction) !== null && _a !== void 0 ? _a : "") + "";
    };
    BlockchainImmutableXTransaction.prototype.wait = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, {
                        blockchain: this.blockchain,
                        hash: this.hash(),
                    }];
            });
        });
    };
    BlockchainImmutableXTransaction.prototype.getTxLink = function () {
        if (!this.transaction) {
            return "";
        }
        return "https://immutascan.io/tx/" + this.transaction;
    };
    Object.defineProperty(BlockchainImmutableXTransaction.prototype, "isEmpty", {
        get: function () {
            return this.transaction === undefined;
        },
        enumerable: false,
        configurable: true
    });
    return BlockchainImmutableXTransaction;
}());
exports.BlockchainImmutableXTransaction = BlockchainImmutableXTransaction;
